hdu 2126 (背包问题之求方案数)

Buy the souvenirs

Time Limit: 10000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 2156    Accepted Submission(s): 820


Problem Description
When the winter holiday comes, a lot of people will have a trip. Generally, there are a lot of souvenirs to sell, and sometimes the travelers will buy some ones with pleasure. Not only can they give the souvenirs to their friends and families as gifts, but also can the souvenirs leave them good recollections. All in all, the prices of souvenirs are not very dear, and the souvenirs are also very lovable and interesting. But the money the people have is under the control. They can’t buy a lot, but only a few. So after they admire all the souvenirs, they decide to buy some ones, and they have many combinations to select, but there are no two ones with the same kind in any combination. Now there is a blank written by the names and prices of the souvenirs, as a top coder all around the world, you should calculate how many selections you have, and any selection owns the most kinds of different souvenirs. For instance:



And you have only 7 RMB, this time you can select any combination with 3 kinds of souvenirs at most, so the selections of 3 kinds of souvenirs are ABC (6), ABD (7). But if you have 8 RMB, the selections with the most kinds of souvenirs are ABC (6), ABD (7), ACD (8), and if you have 10 RMB, there is only one selection with the most kinds of souvenirs to you: ABCD (10).
 

Input
For the first line, there is a T means the number cases, then T cases follow.
In each case, in the first line there are two integer n and m, n is the number of the souvenirs and m is the money you have. The second line contains n integers; each integer describes a kind of souvenir. 
All the numbers and results are in the range of 32-signed integer, and 0<=m<=500, 0
 

Output
If you can buy some souvenirs, you should print the result with the same formation as “You have S selection(s) to buy with K kind(s) of souvenirs”, where the K means the most kinds of souvenirs you can buy, and S means the numbers of the combinations you can buy with the K kinds of souvenirs combination. But sometimes you can buy nothing, so you must print the result “Sorry, you can't buy anything.”
 

Sample Input
  
  
    
    
    
    
2 4 7 1 2 3 4 4 0 1 2 3 4
 

Sample Output
  
  
    
    
    
    
You have 2 selection(s) to buy with 3 kind(s) of souvenirs. Sorry, you can't buy anything.
 

Author
wangye
 

Source

HDU 2007-10 Programming Contest


题解:01背包问题+求方案。网上看到有两种解决方法。

第一种和求背包第K优解类似,再多开一维,用来统计方案数。

状态转移方程如下 : f[i][j][k]=f[i-1][j-t[i]][k-1]+f[i-1][j][k];

( 前 i 个物品在有 j 元的时候买 k 个物品的方法 ,t[i] 为第 i 个物品的价格 )

还是考虑是否选择此物品,如果不选择,则方案数和dp【i-1】【j】【k】一样。如果选择的话,需要dp【i-1】【j- t[i]】【k-1】不为0,则说明前i-1个物品里有j-t【i】元时可以购买k-1个物品,因为dp【i-1】【j】【k】中没有第i个物品,所以两者相加,方案数就求出来了。


第二种在求01背包的基础上,开一个数组用来储存方案数,因为状态在转移的时候,我们只需要保存长度最长的方案数,如果加入第i个物品长度出现更新时,方案数就替换成了比较时的最大状态的方案值。如果发现加入第i个物品时长度不变,方案数则需要更新为不加上第i个物品的方案数+加上第i个物品的新方案数。

状态为dp【i】【j】【2】,dp【i】【j】【0】表示前i个物品有j元时的最大长度,dp【i】【j】【1】用来储存方案数;

if(dp[i][j][0]==dp[i-1][j-p[i]][0]+1)    dp[i][j][1]=dp[i-1][j][1]+dp[i-1][j-p[i]][1];

 if(dp[i][j][0]


#include 
#include 
#include 
#include 
#include 
#include 
#include 
#include 
#include 
#include 
#define mem(p,k) memset(p,k,sizeof(p));
#define lson l,m,rt<<1
#define rson m+1,r,rt<<1|1
#define inf 0x6fffffff
#define LL long long
#define MAX 100010
using namespace std;
int p[510],dp[510][2];
int main(){
    int t,cur=1;
    cin>>t;
    while(t--){
        int m,n,maxx=0,cur=0,maxj;
        scanf("%d%d",&n,&m);
        for(int i=1;i<=n;i++)scanf("%d",p+i);
        mem(dp,0);
        for(int i=0;i<=m;i++)dp[i][1]=1;
        for(int i=1;i<=n;i++){
            for(int j=m;j>=p[i];j--){
                if(dp[j][0]==dp[j-p[i]][0]+1){
                    dp[j][1]+=dp[j-p[i]][1];
                }
                else if(dp[j][0]


你可能感兴趣的:(DP)